; *********************************************
; Vyslen komplexn ady a uren pozice bodu
; *********************************************

MandelbrotTest
	lxi h,0		; vynulovat komplexn promnnou C
	;shld C_Re	; tedy jej relnou sloku
	;shld C_Im	; a imaginrn sloku
	shld C_Re_Root	; tyto vpoty umon peskoit
	shld C_Im_Root	; vpoet prvn iterace
	lhld NormalizedY
	shld C_Im
	lhld NormalizedX
	shld C_Re

	mvi a,MaxIter-1	; FOR IterCnt = MaxIter-1 DOWNTO 1
	sta IterCnt

MandelbrotTestDo
	lhld C_Re	; Re[C]
	call GetRoot	; umocnm
	rnc		; je-li Re[C]^2 > 4, nesplnm souet
			; v podmnce a jsem mimo kivku (CY=0)
	shld C_Re_Root	; a vsledek ulom

	lhld C_Im	; Im[C]
	call GetRoot	; umocnm
	rnc		; je-li Im[C]^2 > 4, nesplnm souet
			; v podmnce a jsem mimo kivku (CY=0)
	shld C_Im_Root	; a vsledek ulom

	xchg		; poctiv vpoet Re[C]^2 + Im[C]^2
	lhld C_Re_Root	; DE=Im[C]^2, HL=Re[C]^2
	dad d		; setu je...
	mov a,h		; nyn vlastn test,
	cpi 4		; zda je souet > 4,
	rnc		; pokud ano, jsem mimo kivku (CY=0)

	lhld C_Re	; iteran vpoet Im[C]
	mov b,h
	mov c,l		 ; BC = Re[C]
	lhld C_Im	 ; HL = Im[C]
	call Mul10Signed ; HL := Re[C] x Im[C]
	dad h		; HL := 2.0 x Re[C] x Im[C]
	xchg		 ; DE := 2.0 x Re[C] x Im[C]
	lhld NormalizedY ; HL := Y pozice testovanho pixelu
	dad d		 ; HL := 2.0 x Re[C] x Im[C] + Y
	shld C_Im	 ; ulom novou hodnotu Im[C]

	lhld C_Im_Root	 ; iteran vpoet Re[C]
	call NegHL
	xchg		 ; DE := -Im[C]
	lhld C_Re_Root	 ; HL := Re[C]
	dad d		 ; HL := Re[C] - Im[C]
	xchg		 ; DE := Re[C] - Im[C]
	lhld NormalizedX ; HL := X pozice testovanho pixelu 
	dad d		 ; HL := Re[C] - Im[C] + X
	shld C_Re	 ; ulom novou hodnotu Re[C]

	lxi h,IterCnt	; odpoet iterac
	dcr m
	jnz MandelbrotTestDo

	stc		; moduly prvk ady 1..MaxIter jsou <2,
	ret		; ada konverguje, pixel uvnit kivky

; ********
; Promnn
; ********

NormalizedX	.dw 0	; normalizovan pozice pixelu X
NormalizedY	.dw 0	; normalizovan pozice pixelu Y
C_Re		.dw 0	; reln st sla C
C_Im		.dw 0	; imaginrn st sla C
C_Re_Root	.dw 0	; druh mocnina reln sti sla C
C_Im_Root	.dw 0	; druh mocnina imaginrn sti C
IterCnt		.db 0	; poitadlo iterac
