; ******************************************************
; Knihovna matematickch operac s pevnou dovou rkou
; Interpreatace bit: S-----II.FFFFFFFF
; ******************************************************

; ************************************************
; Nsoben 10x10 bit signed integer s normalizac
; vsledku pro fixed point interpretaci
; HL := HL x BC
; vstupy:
;  HL = S-----II.FFFFFFFF
;  BC = S-----II.FFFFFFFF
; vstup:
;  HL = S---IIII.FFFFFFFF
; ************************************************

Mul10Signed
	mov a,h		; nast znamnkov bajt HL
	xra b		; kombinace se znamnkovm bajtem BC
	push psw	; uschovat info o znamnku souinu
	xra b		; nechat jen znamnko HL
	cm NegHL	; zporn slo HL pevedu na kladn 

	mov a,b		; u sla v BC
	ana a		; otestuji znamnko
	cm NegBC	; zporn slo pevedu na kladn

	call Mul10	; kladn sla umm nsobit jinde

	pop psw		; podle znamnek nsobence a nsobitele
	rp		; bu nezmnm
			; nebo zmnm znamnko vsledku

; **************************
; Negace znamnka sla v HL
; **************************

NegHL	mov a,h		; standardn vpoet dvojkovho doplku
	cma
	mov h,a
	mov a,l
	cma
	mov l,a
	inx h
	ret

; **************************
; Negace znamnka sla v BC
; **************************

NegBC	mov a,b		; standardn vpoet dvojkovho doplku
	cma
	mov b,a
	mov a,c
	cma
	mov c,a
	inx b
	ret

; ******************************************************
; Vpoet druh mocniny 10-bitovho signed integer sla
; ******************************************************

GetRoot
	mov a,h		; u sla v HL
	ana a		; otestuji znamnko
	cm NegHL	; zporn slo pevedu na kladn x(-1)
	mov a,h		; pedbn test >=2
	cpi 2		; pak mohu hned skonit, protoe
	rnc		; nesplnm podmnku konvergence ady

	mov b,h		; BC := HL
	mov c,l		; (budu nsobit sebou samm)

; *******************************************************
; Nsoben 10x10 bit unsigned integer s normalizac
; vsledku pro fixed point interpretaci
; HL := HL x BC
; vstupy:
;  HL = ------II.FFFFFFFF
;  BC = ------II.FFFFFFFF
; vstup:
;  HL = ----IIII.FFFFFFFF
; *******************************************************
; Pouze tato procedura bude v ppad zjmu nahrazena
; obsluhou hardwarov nsobiky, nap. MH102.
; *******************************************************

Mul10	mov a,h		; MSB nsobitele do A
	xchg		; v E mm LSB nsobitele
	lxi h,0		; vynulovat akumultor vsledku
	rar		; pipravit 2 byit z MSB nsobitele
	rar

	jnc Mul10B9	; pokud je 9. bit nenulov
	dad b		; pitu nsobence k akumultoru
Mul10B9	dad h		; akumultor pak rotuji

	add a		; nsoben 8. bitem nsobitele
	jnc Mul10B8
	dad b
Mul10B8	dad h

	mov a,e		; zbytek nsobitele byl uloen v E
	add a		; nsoben 7. bitem nsobitele
	jnc Mul10B7
	dad b
Mul10B7	dad h

	add a		; nsoben 6. bitem nsobitele
	jnc Mul10B6
	dad b
Mul10B6	dad h

	add a		; nsoben 5. bitem nsobitele
	jnc Mul10B5
	dad b
Mul10B5	dad h

	add a		; nsoben 4. bitem nsobitele
	jnc Mul10B4
	dad b
Mul10B4	dad h

	add a		; nsoben 3. bitem nsobitele
	jnc Mul10B3
	dad b
Mul10B3	dad h

	add a		; nsoben 2. bitem nsobitele
	mov d,a		; zbyl 3 bity do D
	mvi a,0		; A = 0 (nyn u soust akumultoru)
	jnc Mul10B2
	dad b
	aci 0
Mul10B2	dad h
	ral

	xchg		; nsoben 1. bitem nsobitele
	dad h
	xchg
	jnc Mul10B1
	dad b
	aci 0
Mul10B1	dad h
	ral

	xchg		; nsoben 0. bitem nsobitele
	dad h
	xchg
	jnc Mul10B0
	dad b
	aci 0
Mul10B0
	push h		; uschovat podprahov bity v L
	mov l,h		; vsledek zarovnm na desetinnou teku
	mov h,a		; a zformuji do registru HL
	pop psw		; podprahov zaokrouhlovac bit do S
	stc		; vpoet probhl v platnm rozsahu
	rp		; a bude zaokrouhlen dol
	inx h		; zaokrouhlen nahoru
	ret
