; ******************************************************
; Knihovna matematickch operac s pevnou dovou rkou
; Interpreatace bit: S---IIII.FFFFFFFF
; ******************************************************

; ************************************************
; Nsoben 12x12 bit signed integer s normalizac
; vsledku pro fixed point interpretaci
; HL := HL x BC
; vstupy:
;  HL = S---IIII.FFFFFFFF
;  BC = S---IIII.FFFFFFFF
; vstup:
;  HL = S---IIII.FFFFFFFF
; ************************************************

Mul12Signed
	mov a,h		; nast znamnkov bajt HL
	xra b		; kombinace se znamnkovm bajtem BC
	push psw	; uschovat info o znamnku souinu
	xra b		; nechat jen znamnko HL
	cm NegHL	; zporn slo pevedu na kladn x(-1) 

	mov a,b		; u sla v BC
	ana a		; otestuji znamnko
	cm NegBC	; zporn slo pevedu na kladn x(-1)

	call Mul12	; kladn sla umm nsobit jinde

	pop psw		; podle znamnek nsobence a nsobitele
	rp		; bu nezmnm
			; nebo zmnm znamnko vsledku

; **************************
; Negace znamnka sla v HL
; **************************

NegHL	mov a,h		; standardn vpoet dvojkovho doplku
	cma
	mov h,a
	mov a,l
	cma
	mov l,a
	inx h
	ret

; **************************
; Negace znamnka sla v BC
; **************************

NegBC	mov a,b		; standardn vpoet dvojkovho doplku
	cma
	mov b,a
	mov a,c
	cma
	mov c,a
	inx b
	ret

; ******************************************************
; Vpoet druh mocniny 12-bitovho signed integer sla
; ******************************************************

GetRoot
	mov a,h		; u sla v HL
	ana a		; otestuji znamnko
	cm NegHL	; zporn slo pevedu na kladn x(-1)
	mov a,h		; pedbn test >2
	cpi 2		; pak mohu hned skonit, protoe
	rnc		; nesplnm podmnku konvergence ady

	mov b,h		; BC := HL
	mov c,l		; (budu nsobit sebou samm)

; *******************************************************
; Nsoben 12x12 bit unsigned integer s normalizac
; vsledku pro fixed point interpretaci
; HL := HL x BC
; vstupy:
;  HL = ----IIII.FFFFFFFF
;  BC = ----IIII.FFFFFFFF
; vstup:
;  HL = IIIIIIII.FFFFFFFF
; pozn. 4 nejvy bity vsledku se u unsigned nsoben
;       sice potaj korektn, ovem v pouitm kontextu
;       se nevyuvaj a jsou rezervovny pro znamnko
;       u signed interpretac sla
; *******************************************************
; Pouze tato procedura bude v ppad zjmu nahrazena
; obsluhou hardwarov nsobiky, nap. MH102.
; *******************************************************

Mul12	xra a		; vynulovat akumultor vsledku A:D:E
	mov d,a
	mov e,a
	dad h		; peskoit nevyuit MSB nsobitele
	dad h
	dad h
	dad h

	dad h		; nejvym dem nsobitele (bit 11)
	xchg
	jnc Mul12B11	; pokud je nenulov
	dad b		; vynsobm nsobence (implicitn)
	;aci 0		; a vsledek pitu k akumultoru
Mul12B11
	dad h		; spojen akumultor A:D:E pak rotuji
	ral		; o jeden d doleva
	xchg

	dad h		; nsoben 10. bitem nsobitele
	xchg
	jnc Mul12B10
	dad b
	;aci 0		; ACI 0 nen nutno potat do doby,
Mul12B10		; ne do nj me pijt jednika
	dad h
	ral
	xchg

	dad h		; nsoben 9. bitem nsobitele
	xchg
	jnc Mul12B09
	dad b
	;aci 0
Mul12B09
	dad h
	ral
	xchg

	dad h		; nsoben 8. bitem nsobitele
	xchg
	jnc Mul12B08
	dad b
	;aci 0
Mul12B08
	dad h
	ral
	xchg

	dad h		; nsoben 7. bitem nsobitele
	xchg
	jnc Mul12B07
	dad b
	aci 0
Mul12B07
	dad h
	ral
	xchg

	dad h		; nsoben 6. bitem nsobitele
	xchg
	jnc Mul12B06
	dad b
	aci 0
Mul12B06
	dad h
	ral
	xchg

	dad h		; nsoben 5. bitem nsobitele
	xchg
	jnc Mul12B05
	dad b
	aci 0
Mul12B05
	dad h
	ral
	xchg

	dad h		; nsoben 4. bitem nsobitele
	xchg
	jnc Mul12B04
	dad b
	aci 0
Mul12B04
	dad h
	ral
	xchg

	dad h		; nsoben 3. bitem nsobitele
	xchg
	jnc Mul12B03
	dad b
	aci 0
Mul12B03
	dad h
	ral
	xchg

	dad h		; nsoben 2. bitem nsobitele
	xchg
	jnc Mul12B02
	dad b
	aci 0
Mul12B02
	dad h
	ral
	xchg

	dad h		; nsoben 1. bitem nsobitele
	xchg
	jnc Mul12B01
	dad b
	aci 0
Mul12B01
	dad h
	ral
	xchg

	dad h		; nsoben 0. bitem nsobitele
	xchg
	jnc Mul12B00
	dad b
	aci 0
Mul12B00

	push h		; uschovat podprahov bity v L
	mov l,h		; vsledek zarovnm na desetinnou teku
	mov h,a		; a zformuji do registru HL
	pop psw		; podprahov zaokrouhlovac bit do S
	stc		; vpoet probhl v platnm rozsahu
	rp		; a bude zaokrouhlen dol
	inx h		; zaokrouhlen nahoru
	ret
